Attribute VB_Name = "MPrevInst"
' *********************************************************************
'  Copyright 1998, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function IsIconic Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function lstrlenW Lib "kernel32" (ByVal psString As Long) As Long
Private Declare Function lstrlenA Lib "kernel32" (ByVal psString As Long) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal wNewWord As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long

Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Const GWL_WNDPROC = (-4)
Private Const SW_RESTORE = 9
Private Const WM_COPYDATA = &H4A

Private Type COPYDATASTRUCT
   dwData As Long
   cbData As Long
   lpData As Long
End Type

Private m_hWnd As Long
Private m_lpPrev As Long

Public Sub PassCommand(ByVal sWindowText As String)
   Dim hWnd As Long
   Dim sSend As String
   Dim cds As COPYDATASTRUCT
   '
   ' Check for MDI form first, then look for regular form
   ' if no MDI form is found. Use the classname just to
   ' narrow down the potential number of matching windows.
   '
   hWnd = FindWindow("ThunderRT5MDIForm", sWindowText)
   If hWnd = 0 Then
      hWnd = FindWindow("ThunderRT5Form", sWindowText)
   End If
   '
   ' If we've found the target window, restore it, and
   ' pass the command line to it.
   '
   If hWnd Then
      If IsIconic(hWnd) Then
         Call ShowWindow(hWnd, SW_RESTORE)
      End If
      Call SetForegroundWindow(hWnd)

      If Len(Command$) Then
         cds.cbData = LenB(Command$)
         cds.lpData = StrPtr(Command$)
         Call SendMessage(hWnd, WM_COPYDATA, hWnd, cds)
      End If
   End If
End Sub

Public Sub Hook(ByVal hWnd As Long)
   If hWnd = 0 Then ' unhook
      Call SetWindowLong(m_hWnd, GWL_WNDPROC, m_lpPrev)
   Else ' hook into message stream
      m_hWnd = hWnd
      m_lpPrev = SetWindowLong(m_hWnd, GWL_WNDPROC, AddressOf WindowProc)
   End If
End Sub

Private Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Dim cds As COPYDATASTRUCT
   Dim Cmd As String

   If uMsg = WM_COPYDATA Then
      CopyMem cds, ByVal lParam, Len(cds)
      Cmd = Space$(cds.cbData \ 2)
      CopyMem ByVal StrPtr(Cmd), ByVal cds.lpData, cds.cbData
      Call OpenFile(Cmd)
      WindowProc = True
   Else
      WindowProc = CallWindowProc(m_lpPrev, hWnd, uMsg, wParam, lParam)
   End If
End Function

